# coding: utf-8

"""
    PDS Registry Search API

    Registry API enabling advanced search on PDS data and metadata. The API provides end-points to search for bundles, collections and any PDS products with advanced search queries. It also enables to browse the archive hierarchically downward (e.g. collection/s products) or upward (e.g. bundles containing a product). 

    The version of the OpenAPI document: 1.3.0
    Contact: pds-operator@jpl.nasa.gov
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from pds.api_client.api.all_products_api import AllProductsApi


class TestAllProductsApi(unittest.TestCase):
    """AllProductsApi unit test stubs"""

    def setUp(self) -> None:
        self.api = AllProductsApi()

    def tearDown(self) -> None:
        pass

    def test_product_list(self) -> None:
        """Test case for product_list

        search on all PDS data products, including bundles, collections, documentation, context and observational products. 
        """
        pass

    def test_product_properties_list(self) -> None:
        """Test case for product_properties_list

        return a list of all possible searchable metadata fields for products published in the registry 
        """
        pass

    def test_select_by_lidvid(self) -> None:
        """Test case for select_by_lidvid

        returns one PDS Product with the identifier selected from all PDS Products, including bundles, collections, data, documentation, context and observational products. See identifier for details on how it determines what is returned. 
        """
        pass

    def test_select_by_lidvid_all(self) -> None:
        """Test case for select_by_lidvid_all

        returns all product versions with the identifier (lid) selected from all PDS Products. See identifier for details on how it determines what is returned.  note: if given a lidvid, it will be translated to a lid 
        """
        pass

    def test_select_by_lidvid_latest(self) -> None:
        """Test case for select_by_lidvid_latest

        returns one PDS Product with the identifier selected from all PDS Products. See identifier for details on how it determines what is returned. 
        """
        pass


if __name__ == '__main__':
    unittest.main()
